;	(C) 1998-1999  Alexander N. Naumov (2:5020/423.11@fidonet)

IDEAL

MODEL	TPascal

P386
LOCALS	@@

PUBLIC	HugeInc, HugeDec, HugeCompare, HugeStep, CHStoBlock

STRUC	HugeInt
	low	DD	?
	high	DD	?
ENDS

CODESEG

PROC	HugeInc
		ARG	X: FAR PTR HugeInt, N: DWORD
		les	di, [X]
		mov	eax, [N]
		add	[es:di + HugeInt.low], eax
		adc	[es:di + HugeInt.high], 0
		ret
ENDP

PROC	HugeDec
		ARG	X: FAR PTR HugeInt, N: DWORD
		les	di, [X]
		mov	eax, [N]
		sub	[es:di + HugeInt.low], eax
		sbb	[es:di + HugeInt.high], 0
		ret
ENDP

PROC	HugeCompare
		ARG	X: FAR PTR HugeInt, Y: FAR PTR HugeInt
		les	di, [X]
		mov	eax, [es:di + HugeInt.low]
		mov	edx, [es:di + HugeInt.high]
		les	di, [Y]
		sub	eax, [es:di + HugeInt.low]
		sbb	edx, [es:di + HugeInt.high]
		jl	@@2
		jg	@@1
		or	eax, eax
		jz	@@3
	@@1:
		mov	ax, 1
		jmp	@@3
	@@2:
		mov	ax, -1
	@@3:
		ret
ENDP

PROC	HugeStep
		ARG	X: FAR PTR HugeInt, Y: FAR PTR HugeInt, MaxStep: DWORD
		xor	edx, edx
		mov	eax, [MaxStep]
		les	di, [X]
		add	eax, [es:di + HugeInt.low]
		adc	edx, [es:di + HugeInt.high]
		les	di, [Y]
		sub	eax, [es:di + HugeInt.low]
		sbb	edx, [es:di + HugeInt.high]
		jl	@@1
		sub	[MaxStep], eax
	@@1:
		mov	ax, [WORD MaxStep + 0]
		mov	dx, [WORD MaxStep + 2]
		ret
ENDP

PROC	CHStoBlock
		ARG	HeadsPerCylinder: DWORD, SectorsPerTrack: DWORD, Cylinder: DWORD, Head: DWORD, Sector: DWORD, Block: FAR PTR HugeInt
		mov	eax, [Cylinder]
		mul	[HeadsPerCylinder]
		add	eax, [Head]
		adc	edx, 0
		mov	ebx, eax
		mov	eax, edx
		mov	ecx, [SectorsPerTrack]
		mul	ecx
		xchg	ebx, eax
		mul	ecx
		add	edx, ebx
		add	eax, [Sector]
		adc	edx, 0
		sub	eax, 1
		sbb	edx, 0
		les	di, [Block]
		mov	[es:di + HugeInt.low], eax
		mov	[es:di + HugeInt.high], edx
		ret
ENDP

END
